<template>
    <div class="datatable">
        <vue3-datatable
            :rows="rows"
            :columns="columns"
            :totalRows="totalRows"
            :pageSize="store.pageSize"
            :isServerMode="true"
            @change="paging => $emit('change', paging)"
            @rowClick="row => $emit('rowClick', row)"
            @pageSizeChange="(size) => store.setPageSize(size)"
            :pageSizeOptions="NumberRange(10, 30, 1)"
            :rowClass="rowClass ? rowClass: 'cursor-pointer'"
            cellClass="!py-4 !whitespace-nowrap"
            skin="whitespace-nowrap bh-table-hover"
            firstArrow='<svg width="24" height="24" viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg" class="w-4.5 h-4.5 rtl:rotate-180"> <path d="M13 19L7 12L13 5" stroke="currentColor" stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round"/> <path opacity="0.5" d="M16.9998 19L10.9998 12L16.9998 5" stroke="currentColor" stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round"/> </svg>'
            lastArrow='<svg width="24" height="24" viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg" class="w-4.5 h-4.5 rtl:rotate-180"> <path d="M11 19L17 12L11 5" stroke="currentColor" stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round"/> <path opacity="0.5" d="M6.99976 19L12.9998 12L6.99976 5" stroke="currentColor" stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round"/> </svg> '
            previousArrow='<svg width="24" height="24" viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg" class="w-4.5 h-4.5 rtl:rotate-180"> <path d="M15 5L9 12L15 19" stroke="currentColor" stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round"/> </svg>'
            nextArrow='<svg width="24" height="24" viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg" class="w-4.5 h-4.5 rtl:rotate-180"> <path d="M9 5L15 12L9 19" stroke="currentColor" stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round"/> </svg>'
        >
        </vue3-datatable>
    </div>
</template>

<script lang="ts" setup>
    import { NumberRange } from '@/utils/Numbers';
    import Vue3Datatable from '@bhplugin/vue3-datatable';
    import { useAppStore } from '@/stores/index';
    const store = useAppStore();
    defineProps<{
        rows?: Array<any>,
        columns?: Array<any>,
        totalRows?: number,
        rowClass?: string,
    }>();
</script>